BCP_mixture <- function(data, time = 10, am = 1, bm = 1, w0 = 0.2, p0 = 0.2) {
    M <- ncol(data) # 
    n <- nrow(data) #

    Sms <- rep(0, n)
    Sms <- apply(data, 2, function(x) length(x[x!=0])) # non-zero entry for m variables
    Part <- sample(c(rep(0, n-5), rep(1, 5)))
    Part.start <- Part
    
    SumSquares <- apply(data, 2, SumSquare)

    tot <- NULL
    for (i in 1:time){
        x <- NULL
        for(j in 1:(n-2)){
        
          ##calculate W, B
          B0s <- apply(data, 2, function(x) BetweenGroupSum(Part, x))
          W0s <- SumSquares-B0s 
          Part1 <- Part
          Part1[j] <- 1
          B1s <- apply(data, 2, function(x) BetweenGroupSum(Part1, x))
          W1s <- SumSquares- B1s
          N <- BlockNum(Part)
    
          ratioS <- ratioSum(B1s, W1s, B0s, W0s, N, Sms, w0)
          ratioL <- apply(data, 2, function(x) ratioLambda(am, bm, x, j, Part))
        
          ##calculate ratio
          ratioP <- pbeta(p0, N+1, n-N, log.p = TRUE, lower.tail = TRUE)- pbeta(p0, N, n-N+1, log.p = TRUE, lower.tail = TRUE)+ lbeta(N+1, n-N)-lbeta(N, n-N+1) 
          ratio <- sum(c(ratioS, ratioL, M*ratioP))
    
          p <- round(1-1/(1+exp(ratio)), 3)
          if(Part[j]==0){
            RandomNum <- runif(1) 
            if( RandomNum <  p | RandomNum == p) Part[j] <- 1
          } else {
            q <- 1-p
            RandomNum <- runif(1) 
            if(RandomNum < q | RandomNum == q) Part[j] <- 0
        }
          x <- c(x, p)	
        }
        if(sum(Part.start != Part)==0)  Part <- sample(c(rep(0, n-5), rep(1, 5)))
      tot <- rbind(tot, x)
    }
  return(tot)
}
