BetweenGroupSum <- function(partition, sequence){
  seq.mean <- mean(sequence[sequence!=0])
  boundary.start <- c(1, c(1:(length(sequence)-2))[partition==1]+1)
  if(length(boundary.start)==1){
    return(0.0001)
  }
  else{
    boundary.end <- c(boundary.start[-1]-1, length(sequence))
    label <- NULL
    for(i in 1:length(boundary.start)){
      label <- c(label, rep(i, boundary.end[i]- boundary.start[i]+1))
    }
    b <- sum(tapply(sequence, label, function(x){
      if(any(x!=0)){
        return(length(x[x!=0])*(mean(x[x!=0])-seq.mean)^2)
      }
      else{
        return(0.0001)
      }
    }))
    return(b)
  }	
}
